'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = os;
var MACOS = exports.MACOS = 'macOs';
var WINDOWS = exports.WINDOWS = 'windows';

function os() {
  // explicitly set these to avoid issues
  var window = window || null;
  var navigator = navigator || null;
  var process = process || window && window.process || null;

  // via node
  if (process && process.platform) {
    if (process.platform === 'darwin') {
      return MACOS;
    }
    if (process.platform.includes('win')) {
      return WINDOWS;
    }
  }

  // via user agent
  if (navigator && navigator.userAgent) {
    if (navigator.userAgent.includes('Macintosh')) {
      return MACOS;
    }
    if (navigator.userAgent.includes('Windows')) {
      return WINDOWS;
    }
  }

  // default to macOs
  return MACOS;
}